#norm

Norm is primitive ORM for Node.JS (currently only via node-postgres).

## Install

	npm install norm

## Quickstart

	var norm = require('norm');

	new norm.Table({
		tableName: 'role',
		primaryKey: 'id',
		fields: {
			'name': { _type: 'str' },
		},
		relations: {
			'filials': { // many to many (currently not supported)
				fromTable: 'user',
				viaTable: 'user_role',
				fromField: 'role',
				toField: 'user'
			}
		}
	});

	new norm.Table({
		tableName: 'user',
		primaryKey: 'id',
		fields: {
			'name': { _type: 'str' },
		},
		relations: {
			'filials': { // one to many (currently not supported)
				fromTable: 'filial',
				fromField: 'admin'
			}
		}
	});

	new norm.Table({
		tableName: 'filial',
		primaryKey: 'id',
		fields: {
			'name': { _type: 'str' },
			'admin': { _type: 'str' },
		},
		relations: {
			'admin': { // many to one
				fromField: 'admin',
				toTable: 'user',
			}
		}
	});

	var slice = (new norm.Table('filial')).slice(['*', 'admin.*']);
	norm.connect('tcp://user:123@localhost/db', function(err, dbConnect){
		var slice.query
		.limit(100)
		.order('"_self".name')
		.filter('"_self".name like $? and "_self.admin".name like $?', ['%test%', '%TEST%'])
		.rows(dbConnect, function(err, rows){
			console.log(rows);
		});		
	});

	console.log(slice.fields);
	console.log(slice.query._prepareSelectSql().sql);
